
// MDBSlaveReader.cpp : Defines the class behaviors for the application
//---------------------------------------------------------------------
#include "stdafx.h"
#include "MDBSlaveReader.h"
#include "MDBSlaveReaderDlg.h"
#include "Identifier.h"
#include "InterfaceSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CMDBSlaveReaderApp
//-------------------

BEGIN_MESSAGE_MAP(CMDBSlaveReaderApp, CWinApp)
	//{{AFX_MSG_MAP(CMDBSlaveReaderApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

// CMDBSlaveReaderApp construction
//--------------------------------

CMDBSlaveReaderApp::CMDBSlaveReaderApp()
//======================================
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	//-----------------------------------------------------
	m_dwConnection=0;
	m_pCommunicationSocket=NULL;
	m_pControlSocket=NULL;
}

// The one and only CMDBSlaveReaderApp object
//-------------------------------------------
CMDBSlaveReaderApp theApp;

bool CMDBSlaveReaderApp::Connect()
//================================
{
	DWORD dwResult;
	DWORD dwPort;
	CString strIPAddress;
	CString strMessage;
	CString strConnection;

	// Connect dialup connection
	//--------------------------
	strConnection=GetProfileString(REG_SETTINGS,REG_CONNECTION_NAME,_T("BD-4000"));
	dwResult=InternetDial(NULL,(char*)(LPCSTR)strConnection,INTERNET_AUTODIAL_FORCE_ONLINE,&m_dwConnection,0);
	if (dwResult!=ERROR_SUCCESS)
	{
		strMessage.Format(_T("Connect failed, Error: %u\r\n")
			_T("Please make sure to use the correct connection")
			_T("and check the connection settings in windows control panel."),dwResult);
		AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
		m_dwConnection=0;
		return false;
	}
	// Connect communication port
	//---------------------------
	strIPAddress=GetProfileString(REG_SETTINGS,REG_IP_ADDRESS,_T("192.168.1.1"));
	dwPort=GetProfileInt(REG_SETTINGS,REG_PORT_COMMUNICATION,4002);
	m_pCommunicationSocket=new CInterfaceSocket();
	if (m_pCommunicationSocket==NULL)
	{
		strMessage.Format(_T("Memory allocation, Error: %u\r\n"),GetLastError());
		AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
		return false;
	}
	if (!m_pCommunicationSocket->Create(dwPort,SOCK_DGRAM,FD_READ|FD_WRITE))
	{
		strMessage.Format(_T("Create aquisition socket failed, Error: %u\r\n"),GetLastError());
		AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
		return false;
	}
	if (!m_pCommunicationSocket->Connect(strIPAddress,dwPort))
	{
		strMessage.Format(_T("Connect to aquisition socket failed, Error: %u\r\n"),GetLastError());
		AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
		return false;
	}

	// Connect control port
	//---------------------
	dwPort=GetProfileInt(REG_SETTINGS,REG_PORT_CONTROL,4001);
	m_pControlSocket=new CInterfaceSocket();
	if (m_pControlSocket==NULL)
	{
		strMessage.Format(_T("Memory allocation, Error: %u\r\n"),GetLastError());
		AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
		return false;

	}
	if (!m_pControlSocket->Create(dwPort,SOCK_DGRAM,FD_READ))
	{
		strMessage.Format(_T("Create control socket failed, Error: %u\r\n"),GetLastError());
		AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
		return false;
	}
	if (!m_pControlSocket->Connect(strIPAddress,dwPort))
	{
		strMessage.Format(_T("Connect to control socket failed, Error: %u\r\n"),GetLastError());
		AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
		return false;
	}
	return true;
}

bool CMDBSlaveReaderApp::Disconnect()
//===================================
{
	DWORD dwResult;
	CString strMessage;

	// Disconnect aquisition port
	//---------------------------
	if (m_pCommunicationSocket!=NULL)
	{
		m_pCommunicationSocket->Close();
		delete m_pCommunicationSocket;
		m_pCommunicationSocket=NULL;
	}

	// Disconnect control Port
	//------------------------
	if (m_pControlSocket!=NULL)
	{
		m_pControlSocket->Close();
		delete m_pControlSocket;
		m_pControlSocket=NULL;
	}

	// Disconnect dialup connection
	//-----------------------------
	if (m_dwConnection!=0)
	{
		dwResult=InternetHangUp(m_dwConnection,0);
		if (dwResult!=ERROR_SUCCESS)
		{
			strMessage.Format(_T("Hang up failed, Error: %u\r\n")
				_T("Probably still connected."),dwResult);
			AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
			return false;
		}
		m_dwConnection=0;
	}
	return true;
}

bool CMDBSlaveReaderApp::IsConnected()
//====================================
{
	return (m_dwConnection!=0);
}

CInterfaceSocket* CMDBSlaveReaderApp::GetCommunicationSocket()
//============================================================
{
	return m_pCommunicationSocket;
}

CInterfaceSocket* CMDBSlaveReaderApp::GetControlSocket()
//======================================================
{
	return m_pControlSocket;
}

// CMDBSlaveReaderApp initialization
//----------------------------------

BOOL CMDBSlaveReaderApp::InitInstance()
//=====================================
{
	CString strMessage;

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need.
	//----------------------------------------------------------------
#ifdef _AFXDLL
	Enable3dControls();	// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic(); // Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	//----------------------------------------------------------------
	SetRegistryKey(_T("BonusData"));
	LoadStdProfileSettings(10); // Load standard INI file options (including MRU)

	// Connect to device
	//------------------
	if (!AfxSocketInit())
	{
		strMessage.Format(_T("Socket initialization failed, Error: %u\r\n"),GetLastError());
		AfxMessageBox(strMessage,MB_OK|MB_ICONSTOP);
	}
	if (GetProfileInt(REG_SETTINGS,REG_AUTO_CONNECT,true)!=0)
	{
		Connect();
	}

	// Execute application
	//--------------------
	CMDBSlaveReaderDlg MDBSlaveReaderDlg;
	m_pMainWnd=&MDBSlaveReaderDlg;
	MDBSlaveReaderDlg.DoModal();
	return FALSE;
}

int CMDBSlaveReaderApp::ExitInstance() 
//====================================
{
	Disconnect();
	return CWinApp::ExitInstance();
}
